/******************************************************************************
 * SushiExp.cpp
 ******************************************************************************
 $Header:: /N-Patch/Max3.1Exporter/NPatchExp.cpp 2     4/13/01 12:34a Avlacho $
 ******************************************************************************
 * Created by Alex Vlachos (AVlachos@ati.com) on 4-12-2001
 * (C) 2000 ATI Research, Inc.  All rights reserved.
 ******************************************************************************/

// INCLUDES ===================================================================
#include "NPatchExp.h"

// DEFINES ====================================================================
#define SUSHIEXP_CLASS_ID Class_ID(0x11425ea4, 0x3752673a)

// GLOBALS ====================================================================
static HINSTANCE hInstance;
static int controlsInit = FALSE;

//=============================================================================
BOOL WINAPI DllMain(HINSTANCE hinstDLL,ULONG fdwReason,LPVOID lpvReserved) 
{
   hInstance = hinstDLL;

   // Initialize the custom controls. This should be done only once.
   if (!controlsInit)
   {
      controlsInit = TRUE;
      InitCustomControls(hInstance);
      InitCommonControls();
   }
   
   return (TRUE);
}

//=============================================================================
__declspec(dllexport) const TCHAR* LibDescription() 
{
   return GetString(IDS_LIBDESCRIPTION);
}

//=============================================================================
// MUST CHANGE THIS NUMBER WHEN ADD NEW CLASS 
//=============================================================================
__declspec(dllexport) int LibNumberClasses() 
{
   return 1;
}

//=============================================================================
__declspec(dllexport) ClassDesc* LibClassDesc(int i) 
{
   switch(i)
   {
      case 0:
         return GetSushiOutDesc();
      default:
         return 0;
   }
}

//=============================================================================
__declspec(dllexport) ULONG LibVersion() 
{
   return VERSION_3DSMAX;
}

//=============================================================================
__declspec(dllexport) ULONG CanAutoDefer() 
{
   return 1;
}

//=============================================================================
class SushiOutClassDesc:public ClassDesc
{
   public:
      int           IsPublic()     { return 1; }
      void*         Create(BOOL loading = FALSE) { return new SushiOut; } 
      const TCHAR*  ClassName()    { return GetString(IDS_SUOUT); }
      SClass_ID     SuperClassID() { return SCENE_EXPORT_CLASS_ID; } 
      Class_ID      ClassID()      { return SUSHIEXP_CLASS_ID; }
      const TCHAR*  Category()     { return GetString(IDS_CATEGORY); }
};
static SushiOutClassDesc SushiOutDesc;

//=============================================================================
ClassDesc* GetSushiOutDesc()
{
   return &SushiOutDesc;
}

//=============================================================================
TCHAR *GetString(int id)
{
   static TCHAR buf[256];

   if (hInstance)
      return LoadString(hInstance, id, buf, sizeof(buf)) ? buf : NULL;

   return NULL;
}

//=============================================================================
int SushiOut::ExtCount()
{
   return 1;
}

//=============================================================================
const TCHAR* SushiOut::Ext(int n)
{
   switch (n)
   {
      case 0:
         //This cause a static string buffer overwrite
         //return GetString(IDS_EXTENSION1);
         return _T("m");
   }
   return _T("");
}

//=============================================================================
const TCHAR* SushiOut::LongDesc()
{
   return GetString(IDS_LONGDESC);
}

//=============================================================================
const TCHAR* SushiOut::ShortDesc()
{
   return GetString(IDS_SHORTDESC);
}

//=============================================================================
const TCHAR* SushiOut::AuthorName() 
{
   return _T("Alex Vlachos");
}

//=============================================================================
const TCHAR* SushiOut::CopyrightMessage() 
{
   return GetString(IDS_COPYRIGHT);
}

//=============================================================================
const TCHAR* SushiOut::OtherMessage1() 
{
   return _T("");
}

//=============================================================================
const TCHAR* SushiOut::OtherMessage2() 
{
   return _T("");
}

//=============================================================================
unsigned int SushiOut::Version()
{
   return 100;
}

//=============================================================================
static BOOL CALLBACK AboutBoxDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
   switch (msg)
   {
      case WM_INITDIALOG:
         CenterWindow(hWnd, GetParent(hWnd)); 
         break;

      case WM_COMMAND:
         switch (LOWORD(wParam))
         {
            case IDOK:
               EndDialog(hWnd, 1);
               break;
         }
         break;

      default:
         return FALSE;
   }
   return TRUE;
}       

//=============================================================================
void SushiOut::ShowAbout(HWND hWnd)
{
   DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, AboutBoxDlgProc, 0);
}

//=============================================================================
BOOL SushiOut::SupportsOptions(int ext, DWORD options)
{
   assert(ext == 0);   // We only support one extension

   return FALSE; //(options == SCENE_EXPORT_SELECTED) ? TRUE : FALSE;
}
